#!/usr/bin/perl
# Čte označkovaný korpus v Brillově formátu s lemmaty. Vybírá tokeny se stupňovanými přídavnými jmény, zbytek zahazuje.
# (c) 2007 Dan Zeman <zeman@ufal.mff.cuni.cz>
# Licence: GNU GPL

use utf8;
use open ":utf8";
binmode(STDIN, ":utf8");
binmode(STDOUT, ":utf8");
binmode(STDERR, ":utf8");

while(<>)
{
    # Odstranit konec řádku.
    s/\r?\n$//;
    # Rozsekat řádek na tokeny.
    @tok = split(/\s+/, $_);
    # Vybrat tokeny přídavných jmen ve druhém nebo třetím stupni.
    @tok = grep {m=.*/.*/A....----[23].----=} @tok;
    # Vypsat vybrané tokeny.
    foreach my $token (@tok)
    {
        # Převést na malá písmena (ale jen slovní tvar a lemma, ne značku!)
        $token =~ s=^(.*/.*/)=\L$1\E=;
        # 3. stupeň převést na 2. Dát pozor, aby se nám nepletl s předponou záporu ("nejednoznačný").
        $token =~ s=^nej(.*/.*/A....----)3=${1}2=;
        # Odstranit zápor. Předpony 3. stupně už jsou pryč, ale i tak dát pozor, abychom nechytli např. "neratovický".
        $token =~ s=^ne(.*/.*/A....----.)N----$=$1A----=;
        # Převést na 1. pád, ale neodstranit stupeň.
        $token =~ s-^([^/]+)(ho|mu|m|ch|mi)/-$1/-;
        # Odstranit značku. Po úpravách pádu a stupně už stejně není pravdivá.
        $token =~ s-/[^/]*$--;
        $stat{$token}++;
    }
}
# Vypsat statistiku.
foreach my $token (sort(keys(%stat)))
{
    print("$token\n");
}
print STDERR ("Celkem nalezeno ", scalar(keys(%stat)), " různých přídavných jmen.\n");
