#!/usr/bin/perl
# Čte příklady 2. stupňů přídavných jmen získané skriptem astupne.pl. Analyzuje způsob jejich tvoření.
# (c) 2007 Dan Zeman <zeman@ufal.mff.cuni.cz>
# Licence: GNU GPL

use utf8;
use open ":utf8";
binmode(STDIN, ":utf8");
binmode(STDOUT, ":utf8");
binmode(STDERR, ":utf8");

$n_prav = $n_neprav = 0;
while(<>)
{
    # Odstranit konec řádku.
    s/\r?\n$//;
    # Přečíst 1. a 2. stupeň přídavného jména.
    my ($com, $pos) = split(/\//, $_);
    # Přeskakovat měkká přídavná jména.
    next if($pos =~ m/í$/);
    # Zjistit druh přípony.
    my $pripona;
    if($com =~ m/[eě]jší$/)
    {
        $pripona = "ejší";
        print("pravidelně:\t$pos/$com\n");
        $n_prav++;
    }
    else
    {
        $pripona = "nepravidelná";
        push(@nepravidelna, "nepravidelně:\t$pos/$com\n");
        $n_neprav++;
    }
}
print("\n");
print(@nepravidelna);
print("\n");
$n = $n_prav+$n_neprav;
print("Celkem nalezeno $n 2. stupňů tvrdých vzorů, z toho $n_prav pravidelných (-e/ější) a $n_neprav nepravidelných.\n");
