#!/usr/bin/perl
# Spočítá počet různých hodnot určitého datového sloupce v CoNLL datech.
# Výsledné číslo použiju ve článku s popisem systému.
# Copyright © 2009 Dan Zeman <zeman@ufal.mff.cuni.cz>
# Licence: GNU GPL

use utf8;
use open ":utf8";
binmode(STDIN, ":utf8");
binmode(STDOUT, ":utf8");
binmode(STDERR, ":utf8");

while(<STDIN>)
{
    next if(m/^\s*$/);
    s/\r?\n$//;
    my @pole = split(/\s+/, $_);
    # Následující poznámky se týkají formátu CoNLL 2006.
    # Sloupec č. 3 obsahuje CPOSTAG.
    # Sloupec č. 4 obsahuje POSTAG.
    # Sloupec č. 5 obsahuje FEATS.
#    $hash{$pole[10]}++;
    if(@ARGV)
    {
        $hash{$pole[$ARGV[0]]}++;
    }
    else
    {
        $hash{$pole[4]}++;
    }
    $n++;
}
# Pro kontrolu, že počítám správný sloupec, raději vypsat i jednotlivé nalezené hodnoty.
foreach my $klic (sort(keys(%hash)))
{
    print("$klic\n");
}
print(scalar(keys(%hash)), " / $n\n");
