#!/usr/bin/perl
# Vytáhne z CoNLL souboru hodnoty n-tého sloupce. Potřeba pro budování seznamů značek pro Malt parser.
# (c) 2007 Dan Zeman <zeman@ufal.mff.cuni.cz>
# Licence: GNU GPL

use utf8;
use open ":utf8";
binmode(STDIN, ":utf8");
binmode(STDOUT, ":utf8");
binmode(STDERR, ":utf8");
use Getopt::Long;

# Zjistit volby.
$sloupec = 4; # 0 = index, 1 = slovo, 2 = lemma, 3 = hrubá značka, 4 = značka, 5 = rysy, 6 = index rodiče, 7 = druh závislosti
GetOptions
(
    'column=i' => \$sloupec,
);
while(<>)
{
    # Přeskočit prázdné řádky, které oddělují věty.
    next if(m/^\s*$/);
    # Odstranit konec řádku.
    s/\r?\n$//;
    # Rozdělit řádek na hodnoty jednotlivých atributů uzlu.
    my @pole = split(/\t/, $_);
    # Zapamatovat si hodnotu v n-tém sloupci.
    $hash{$pole[$sloupec]}++;
}
# Vypsat seznam nalezených hodnot.
@hodnoty = sort(keys(%hash));
foreach my $hodnota (@hodnoty)
{
    print("$hodnota\n");
}
