#!/usr/bin/perl
# Převede treebank z formátu CSTS na označkovaný tokenizovaný text, na kterém lze trénovat Brillův tagger.
# (c) 2007 Dan Zeman <zeman@ufal.mff.cuni.cz>
# Licence: GNU GPL

sub usage
{
    print STDERR ("Usage: csts2brill.pl [-l]\n");
    print STDERR ("  -l: include lemmas (format form/lemma/tag)\n");
}

use utf8;
use open ":utf8";
binmode(STDIN, ":utf8");
binmode(STDOUT, ":utf8");
binmode(STDERR, ":utf8");
use csts1;

if(@ARGV && $ARGV[0] =~ m/^-l/i)
{
    $zahrnout_lemmata = 1;
    shift(@ARGV);
}
csts::cist(\&zpracovat_vetu);



#------------------------------------------------------------------------------
# Zpracuje větu.
#------------------------------------------------------------------------------
sub zpracovat_vetu
{
    my $veta = shift;
    my @x = @{$veta};
    shift(@x);
    print(join(" ", map
    {
        $_->{form} =~ s/&/&amp;/g;
        $_->{form} =~ s-/-&slash;-g;
        $_->{form} =~ s/ /&space;/g;
        my $token = $_->{form};
        if($zahrnout_lemmata)
        {
            $_->{lemma} =~ s/-.*//;
            $_->{lemma} =~ s/_.*//;
            $_->{lemma} =~ s/`.*//;
            $_->{lemma} =~ s/&/&amp;/g;
            $_->{lemma} =~ s-/-&slash;-g;
            $_->{lemma} =~ s/ /&space;/g;
            $token .= "/".$_->{lemma};
        }
        $_->{tag} =~ s/&/&amp;/g;
        $_->{tag} =~ s-/-&slash;-g;
        $_->{tag} =~ s/ /&space;/g;
        $token."/".$_->{tag}
    }
    @x), "\n");
}
