#!/usr/bin/perl
# Vyrobí statistiku ručních morfologických značek v souboru CSTS.
# (c) 2006 Dan Zeman <zeman@ufal.mff.cuni.cz>
# Licence: GNU GPL

sub usage
{
    print STDERR ("Usage: csts_tag_statistics.pl [-e element] [-f 0] < input.csts\n");
    print STDERR ("  element: SGML whose contents is counted; default t\n");
    print STDERR ("  f: frequencies on/off; default on; if off, only prints list of tags\n");
    print STDERR ("  input:   STDIN or arguments; CSTS format\n");
    print STDERR ("  output:  table of tags and their frequencies\n");
}

use utf8;
use open ":utf8";
binmode(STDIN, ":utf8");
binmode(STDOUT, ":utf8");
binmode(STDERR, ":utf8");
use Getopt::Long;

$element = "t";
$frequencies = 1;
GetOptions('element=s' => \$element, 'frequencies=i' => \$frequencies);
while(<>)
{
    if(m/<$element>([^<\r\n]*)/)
    {
        $stat{$1}++;
        $jmenovatel++;
    }
}
@znacky = sort{$stat{$b} <=> $stat{$a}}(keys(%stat));
foreach my $znacka (@znacky)
{
    print("$znacka");
    if($frequencies)
    {
        my $rel = $jmenovatel ? $stat{$znacka}/$jmenovatel : 0;
        print("\t$stat{$znacka}\t$rel");
    }
    print("\n");
}
