#!/usr/bin/perl
# Discards long and dirty sentences (one tokenized sentence per input line).
# (c) 2006 Dan Zeman <zeman@ufal.mff.cuni.cz>
# License: GNU GPL

use utf8;
use open ":utf8";
binmode(STDIN, ":utf8");
binmode(STDOUT, ":utf8");
binmode(STDERR, ":utf8");

while(<>)
{
    # Remove line break.
    s/\r?\n$//;
    # Split sentence into words.
    my @words = split(/\s+/, $_);
    # Discard sentences longer than 40 words.
    my $length = scalar(@words);
    $max = $length if($length>$max);
    if($length>40)
    {
        $n_length++;
        next;
    }
    # Discard sentences containing too many dashes and numbers.
    if(scalar(grep{m/[-\d]/}(@words)) > scalar(@words)*0.4)
    {
        $n_dirty++;
        next;
    }
    # Print undiscarded sentences.
    print("$_\n");
}
print STDERR ("The longest sentence had $max words.\n");
print STDERR ("$n_length sentences discarded due to their length.\n");
print STDERR ("$n_dirty short sentences discarded due to their \"dirty\" contents.\n");
