#!/usr/bin/perl
# Spočítá neprojektivity v souboru ve formátu CoNLL 2006.
# Copyright © 2009 Dan Zeman <zeman@ufal.mff.cuni.cz>
# Licence: GNU GPL

use utf8;
use open ":utf8";
binmode(STDIN, ":utf8");
binmode(STDOUT, ":utf8");
binmode(STDERR, ":utf8");
use neproj;

$veta[0] = -1;
while(<>)
{
    # Odstranit znak konce řádku.
    s/\r?\n$//;
    # Jestliže je řádek prázdný, skončila věta.
    if(m/^\s*$/)
    {
        my @neproj = neproj::zjistit(@veta);
        $n_slov += scalar(@veta)-1;
        $n_neproj += scalar(grep {$_} (@neproj));
        $n_vet++;
        $n_vet_neproj++ if(grep {$_} (@neproj));
        splice(@veta);
        $veta[0] = -1;
    }
    else
    {
        # Rozdělit řádek na jednotlivé atributy slova.
        my @slovo = split(/\t/, $_);
        # Z každého slova si zapamatovat položku HEAD - odkaz na rodiče.
        push(@veta, $slovo[6]);
    }
}
print("slov   = $n_slov\n");
print("neproj = $n_neproj\n");
print("podil  = ", $n_neproj/$n_slov, "\n") if($n_slov);
print("vet    = $n_vet\n");
print("neproj = $n_vet_neproj\n");
print("podil  = ", $n_vet_neproj/$n_vet, "\n") if($n_vet);
