#!/usr/bin/perl
# Upraví uzávorkovaná data Penn Tree Banku, aby na každém řádku byl právě jeden strom (věta).
# (c) 2006 Dan Zeman <zeman@ufal.mff.cuni.cz>
# Licence: GNU GPL

use utf8;
use open ":utf8";
binmode(STDIN, ":utf8");
binmode(STDOUT, ":utf8");
binmode(STDERR, ":utf8");

while(<>)
{
    # Vždy, když se vyrovná počet levých a pravých závorek, končí věta.
    # Řetězce přilepené k levým závorkám jsou neterminály.
    # Ostatní řetězce jsou vesměs slova (tokeny), ale "*-1", "*-2"..., "*U*", "*" je stopa nebo něco takového.
    s/\r?\n$//;
    # Spočítat levé a pravé závorky v právě načteném řádku.
    my ($nlz, $npz);
    my $lz = $_;
    $lz =~ s/[^(]//g;
    $nlz = length($lz);
    my $pz = $_;
    $pz =~ s/[^)]//g;
    $npz = length($pz);
    # Přičíst počty závorek k celkovým počtům a zjistit, zda jde o konec věty.
    $nlz_celkem += $nlz;
    $npz_celkem += $npz;
    my $konec_vety = $nlz_celkem>0 && $nlz_celkem==$npz_celkem;
    # Zbytek připojit ke dříve načteným částem věty.
    $veta .= " $_ ";
    # Jestliže je tohle konec věty, vypsat ji a vymazat proměnné.
    if($konec_vety)
    {
        # Smazat mezery před pravými závorkami, pokud tam jsou (vadilo by to programu evalb).
        $veta =~ s/\s+\)/\)/g;
        # Odstranit přebytečné mezery.
        $veta =~ s/^\s+//;
        $veta =~ s/\s+$//;
        $veta =~ s/\s+/ /g;
        # Vložit neterminál nejvyšší úrovně za první levou závorku, pokud tam není.
        $veta =~ s/^\(\s/\(TOP /;
        # Vypsat větu.
        print("$veta\n");
        # Vyčistit proměnné.
        $veta = "";
        $nlz_celkem = 0;
        $npz_celkem = 0;
    }
}
