#!/usr/bin/perl
# Najde v Charniakově výstupu řádky, jejichž analýza se nepovedla, a doplní výchozí analýzu.
# (c) 2006 Dan Zeman <zeman@ufal.mff.cuni.cz>
# Licence: GNU GPL

use utf8;
use open ":utf8";
binmode(STDIN, ":utf8");
binmode(STDOUT, ":utf8");
binmode(STDERR, ":utf8");

while(<>)
{
    # Danova úprava Charniakových zdrojáků: nepovedené věty začínají takhle:
    if(m/^__FAILED__\t(.*)/)
    {
        my $veta = $1;
        $veta =~ s/\r?\n$//;
        my @slova = split(/\s+/, $veta);
        # All words will be tagged as foreign words.
        my @tagged = map{"(FW $_)"}(@slova);
        # All words will constitue one fragment constituent.
        $_ = "(S1 (FRAG ".join(" ", @tagged)."))\n";
    }
    print;
}
