#!/usr/bin/perl
# Rozdělí CSTS soubor na prvních N vět a zbytek.
# (c) 2007 Dan Zeman <zeman@ufal.mff.cuni.cz>
# Licence: GNU GPL

sub usage
{
    print STDERR ("Usage: split_csts.pl < input [-head N] output1 output2\n");
    print STDERR ("  head:    how many initial sentences go to output1 (default=0)\n");
    print STDERR ("  output1: path where to put the first HEAD sentences\n");
    print STDERR ("  output2: path where to put the rest\n");
}

use utf8;
use open ":utf8";
binmode(STDIN, ":utf8");
binmode(STDOUT, ":utf8");
binmode(STDERR, ":utf8");
use Getopt::Long;
use csts1;



# Get options.
$head = 0;
GetOptions('head=i' => \$head);
if(scalar(@ARGV)<2)
{
    usage();
    die;
}
# Odebrat cesty k výstupům z @ARGV, aby je tam neviděla čtecí procedura a nepovažovala je za vstupy.
$vystup[0] = shift(@ARGV);
$vystup[1] = shift(@ARGV);
# Otevřít výstup 1.
open(OUTPUT, ">$vystup[0]") or die("Cannot write to $vystup[0]: $!\n");
csts::cist(\&zpracovat_vetu);
close(OUTPUT);



#------------------------------------------------------------------------------
# Zpracuje strom.
#------------------------------------------------------------------------------
sub zpracovat_vetu
{
    my $veta = shift;
    # Kolikátá je to věta?
    $i_veta++;
    # Jestliže je to první věta druhého souboru, zavřít výstup 1 a otevřít výstup 2.
    if($i_veta==$head+1)
    {
        close(OUTPUT);
        open(OUTPUT, ">$vystup[1]") or die("Cannot write to $vystup[1]: $!\n");
    }
    # Vytisknout větu.
    print OUTPUT (csts::zakodovat($veta));
}
