#!/usr/bin/perl
# Převede švédské značky Mamba na anglické značky Penn v souboru CSTS.
# Nejdříve odstraní informace, které nejsou i v dánské sadě Parole, kvůli porovnatelnosti obou sad.
# (c) 2007 Dan Zeman <zeman@ufal.mff.cuni.cz>
# Licence: GNU GPL

use utf8;
use open ":utf8";
binmode(STDIN, ":utf8");
binmode(STDOUT, ":utf8");
binmode(STDERR, ":utf8");
use csts1;
use tagset::da::conll;
use tagset::sv::mamba;
use tagset::en::penn;



csts::cist(\&zpracovat_vetu);



#------------------------------------------------------------------------------
# Zpracuje strom.
#------------------------------------------------------------------------------
sub zpracovat_vetu
{
    my $veta = shift;
    # Dekódovat morfologické značky do sad vlastností.
    foreach my $uzel (@{$veta})
    {
        $uzel->{tag} =~ s/\t.*//;
        $uzel->{features} = tagset::sv::mamba::decode($uzel->{tag});
        $uzel->{tag} = tagset::da::conll::encode($uzel->{features});
        $uzel->{features} = tagset::da::conll::decode($uzel->{tag});
        $uzel->{tag} = tagset::sv::mamba::encode($uzel->{features});
        $uzel->{features} = tagset::sv::mamba::decode($uzel->{tag});
        $uzel->{tag} = tagset::en::penn::encode($uzel->{features});
    }
    # Vytisknout větu.
    csts::psat_vetu($veta);
}
